# Contributor Covenant Code of Conduct

## Our Commitment

We, as members, contributors, and leaders, solemnly pledge to ensure that participation in our community is an experience free from harassment for everyone, regardless of their age, body size, visible or invisible disabilities, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, religion, or sexual identity and orientation.

We commit to engaging in behaviors that foster an open, welcoming, diverse, inclusive, and healthy community.

## Our Standards

Positive behaviors that contribute to a thriving community environment encompass:

- Demonstrating empathy and kindness towards others
- Showing respect for diverse opinions, viewpoints, and experiences
- Providing and graciously accepting constructive feedback
- Acknowledging mistakes, offering apologies to those affected, and learning from these experiences
- Prioritizing the greater good of the community over individual interests

Unacceptable behaviors include:

- Employing sexualized language or imagery, as well as making sexual advances of any nature
- Engaging in trolling, making insulting or derogatory comments, and launching personal or political attacks
- Participating in public or private harassment
- Revealing others' private information, such as physical or email addresses, without their explicit consent
- Any other conduct that could reasonably be deemed inappropriate in a professional setting

## Enforcement Responsibilities

Community leaders bear the responsibility of clarifying and enforcing our standards of acceptable behavior. They will take fair and appropriate corrective actions in response to any behavior they deem inappropriate, threatening, offensive, or harmful.

Community leaders have the authority and duty to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that do not align with this Code of Conduct. They will communicate the reasons for moderation decisions when deemed necessary.

## Scope

This Code of Conduct is applicable in all community spaces and extends to instances when an individual officially represents the community in public spaces. Examples of representing our community include using an official email address, posting through an official social media account, or acting as an appointed representative at an online or offline event.

## Enforcement

Instances of abusive, harassing, or otherwise unacceptable behavior may be reported to the community leaders responsible for enforcement at zrwusa@gmail.com. All complaints will be promptly and fairly reviewed and investigated.

All community leaders are obligated to uphold the privacy and security of the reporter of any incident.

## Enforcement Guidelines

Community leaders will adhere to these Community Impact Guidelines when determining consequences for actions that violate this Code of Conduct:

### Correction

Community Impact: The use of inappropriate language or other unprofessional or unwelcome behavior within the community.

Consequence: A private, written warning from community leaders, providing clarity regarding the nature of the violation and an explanation of why the behavior was inappropriate. A public apology may be requested.

### Warning

Community Impact: A violation through a single incident or a series of actions.

Consequence: A warning with consequences for continued behavior. No interaction with the individuals involved, including unsolicited interaction with those enforcing the Code of Conduct, is allowed for a specified period of time. This includes refraining from interactions in community spaces as well as external channels like social media. Violating these terms may result in a temporary or permanent ban.

### Temporary Ban

Community Impact: A serious violation of community standards, including sustained inappropriate behavior.

Consequence: A temporary ban from any form of interaction or public communication with the community for a specified period. No public or private interaction with the individuals involved, including unsolicited interaction with those enforcing the Code of Conduct, is permitted during this time. Violating these terms may lead to a permanent ban.

### Permanent Ban

Community Impact: Demonstrating a pattern of violating community standards, including sustained inappropriate behavior, harassment of an individual, or aggression towards or disparagement of classes of individuals.

Consequence: A permanent ban from any form of public interaction within the community.

[//]: # (## Attribution)

[//]: # ()
[//]: # (The Community Impact Guidelines drew inspiration from Mozilla's code of conduct enforcement ladder.)

[//]: # ()
[//]: # (For answers to common questions about this code of conduct, please refer to the FAQ at https://www.zrwusa.org/faq.)

[//]: # ()
[//]: # (Translations are available at https://www.zrwusa.org/translations.)
